﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using Telerik.Pivot.Core;
using Telerik.Windows.Controls.Pivot;

namespace RadPivotGrid_WPF_723379
{
    public class CellTemplateSelector : DataTemplateSelector
    {
        public string EnteredText { get; set; }
        public bool IsSearchButtonClicked { get; set; }

        public CellAggregateValue SelectedCell { get; set; }

        public DataTemplate SelectedTemplate { get; set; }
        public DataTemplate RedTemplate { get; set; }

        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            var cellAggregate = item as CellAggregateValue;
            if (cellAggregate != null)
            {
                var description = cellAggregate.Description as PropertyAggregateDescription;
                if (cellAggregate.RowGroup.Type == GroupType.BottomLevel && cellAggregate.ColumnGroup.Type == GroupType.BottomLevel)
                {
                    string cellValue = cellAggregate.Value.ToString();

                    if (this.EnteredText != null)
                    {
                        if (cellValue.Contains(this.EnteredText))
                        {
                            if (this.IsSearchButtonClicked && this.ShouldSelectCell(cellAggregate))
                            {
                                this.SelectedCell = cellAggregate;
                                return this.RedTemplate;
                            }
                            else if (!this.IsSearchButtonClicked)
                            {
                                return this.SelectedTemplate;
                            }
                        }
                    }
                }
            }

            return base.SelectTemplate(item, container);
        }

        private bool ShouldSelectCell(CellAggregateValue cellAggregate)
        {
            if (this.SelectedCell == null)
            {
                return true;
            }

            if (this.SelectedCell.Value == cellAggregate.Value)
            {
                return true;
            }

            return false;
        }
    }
}
